import { Observable } from "rxjs"

export class ConfigHelper {

    // information sent after creation of applicationId by mail
    OCR_url = "***";
    OCR_url_status = "***";
    LIVENESS_url = "***";
    FACE_MATCHING_url = "***";
    skyid_fa_sdk_params_url = "***";
    Recover_Face_Matching_Result_URL = "***";

    institution_id = "***";
    skyid_fa_sdk_user = "***";
    skyid_fa_sdk_password = "***";
    skyid_fa_sdk_token = "***";
    skyid_fa_sdk_appId = "***";

    constructor() {

    }

    setFileImage(my_selfie_canvas: any) : File {
        const canvas_bin = this.skyid_fa_canvas2binary(my_selfie_canvas);
        return new File([canvas_bin], "skyid_fa_selected_frame.jpg", { type: "application/octet-stream" })
    }

    skyid_fa_canvas2binary(req_canvas: any) {
        let skyid_fa_canvas_data = req_canvas.toDataURL('image/jpeg', 1.0);
        skyid_fa_canvas_data = skyid_fa_canvas_data.replace('data:image/jpeg;base64,', '');
        return this.skyid_fa_base64ToArrayBuffer(skyid_fa_canvas_data)
    }
    
    skyid_fa_base64ToArrayBuffer(base64: any) {
        const binary_string = window.atob(base64);
        const len = binary_string.length;
        var bytes = new Uint8Array(len);
        for (var i = 0; i < len; i++) {
            bytes[i] = binary_string.charCodeAt(i);
        }
        return bytes.buffer;
    }

    resizeImage(file: File): Observable<File> {
        // in bytes, compress images larger than 1MB
        const fileSizeMax = 1 * 1024 * 1024
        const defaultQualityRatio = 0.7
        const imageType = file.type || 'image/jpeg'
        const reader = new FileReader()
        reader.readAsDataURL(file)
    
        return Observable.create((observer: { next: (arg0: File) => void; error: (arg0: ProgressEvent<FileReader>) => any }) => {
            // This event is triggered each time the reading operation is successfully completed.
            reader.onload = e => {
            // Create an html image element
            const img = this.createImage(e)
            // Determines the ratios to compress the image
            // let withHeightRatio = (imgWH > widthHeightMax) ? widthHeightMax/imgWH : defaultWidthHeightRatio
            let qualityRatio = (file.size > fileSizeMax) ? fileSizeMax/file.size : defaultQualityRatio
            // Fires immediately after the browser loads the object
            img.onload = () => { 
                const canvas = document.createElement('canvas')
                const ctx = <CanvasRenderingContext2D>canvas.getContext('2d')
                // resize width, height
                canvas.width = 1000;
                canvas.height = 600;
                if(img.width < img.height){
                canvas.width = 600;
                canvas.height = 1000;
                }
    
                if(img.width > canvas.width || img.height > canvas.height){
                ctx.drawImage(img, 0, 0, canvas.width, canvas.height)
                ctx.canvas.toBlob(
                    // callback, called when blob created
                    blob => { 
                    observer.next(new File(
                        [blob!],
                        file.name,
                        {
                        type: imageType,
                        lastModified: Date.now(),
                        }
                    ))
                    },
                    imageType,
                    qualityRatio, // reduce image quantity 
                )
                }
            }
          }
            // Catch errors when reading file
            reader.onerror = error => observer.error(error)
        })
    }
        
    private createImage(ev:any) {
        let imageContent = ev.target.result
        const img = new Image()
        img.src = imageContent
        return img
    }
}